// Generated by CoffeeScript 1.7.1
(function() {
  var Bottleneck,
    __slice = [].slice;

  Bottleneck = (function() {
    function Bottleneck(maxNb, minTime) {
      this.maxNb = maxNb != null ? maxNb : 0;
      this.minTime = minTime != null ? minTime : 0;
      this._nextRequest = Date.now();
      this._nbRunning = 0;
      this._queue = [];
      this._timeouts = [];
    }

    Bottleneck.prototype._tryToRun = function() {
      var done, next, wait;
      if ((this._nbRunning < this.maxNb || this.maxNb <= 0) && this._queue.length > 0) {
        this._nbRunning++;
        wait = Math.max(this._nextRequest - Date.now(), 0);
        this._nextRequest = Date.now() + wait + this.minTime;
        next = this._queue.shift();
        done = false;
        return this._timeouts.push(setTimeout((function(_this) {
          return function() {
            return next.task.apply({}, next.args.concat(function() {
              var _ref;
              if (!done) {
                done = true;
                _this._nbRunning--;
                _this._tryToRun();
                return (_ref = next.cb) != null ? _ref.apply({}, Array.prototype.slice.call(arguments, 0)) : void 0;
              }
            }));
          };
        })(this), wait));
      }
    };

    Bottleneck.prototype.submit = function() {
      var args, cb, task, _i;
      task = arguments[0], args = 3 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 1) : (_i = 1, []), cb = arguments[_i++];
      this._queue.push({
        task: task,
        args: args,
        cb: cb
      });
      return this._tryToRun();
    };

    Bottleneck.prototype.changeSettings = function(maxNb, minTime) {
      this.maxNb = maxNb != null ? maxNb : this.maxNb;
      this.minTime = minTime != null ? minTime : this.minTime;
      return this;
    };

    Bottleneck.prototype.stopAll = function() {
      var a, _i, _len, _ref;
      _ref = this._timeouts;
      for (_i = 0, _len = _ref.length; _i < _len; _i++) {
        a = _ref[_i];
        clearTimeout(a);
      }
      return this._tryToRun = function() {};
    };

    return Bottleneck;

  })();

  module.exports = Bottleneck;

}).call(this);
